package br.sg3.connector3;

import java.util.HashMap;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import org.jboss.ejb3.annotation.ResourceAdapter;

import br.sg3.connector.lib.Defs;
import br.sg3.connector3.par.Parameters;

@MessageDriven(
	 name = "ConnectorMDB", activationConfig = {  
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),  
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/testConnector"),
        @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "1")
     })  
   
@ResourceAdapter("hornetq-ra.rar") 
@TransactionManagement(TransactionManagementType.BEAN)
public class ConnectorMDB implements MessageListener {
	
    @Resource
    private MessageDrivenContext context;
	
    public ConnectorMDB() {
        super();
    }

    private MessageProcessing mgp = new MessageProcessing();

    public void onMessage(Message message) {
    	System.out.println("[#### Receiver ####] Recebendo mensagem...");
        //String placa = null;
        try {
           
        	if (message instanceof ObjectMessage) {
                
            	ObjectMessage objMessage = (ObjectMessage) message;
                Object obj = objMessage.getObject();
                
                if (obj instanceof Parameters) {
                	
                	System.out.println("[#### Receiver ####] ACTION  = "+((Parameters)obj).getAction());
                	System.out.println("[#### Receiver ####] PROCESS = "+((Parameters)obj).getProcess());
                	
                	HashMap<String, String> hashParams = new HashMap<String, String>();
                	
                	hashParams.put(Defs.ParAction, ((Parameters)obj).getAction());
                	hashParams.put(Defs.ParPrc, ((Parameters)obj).getProcess());
                	                	
           			mgp.prepare(hashParams);
           			System.out.println("[#### Receiver ####] Iniciando Processo...");
           			mgp.startIt();
           			System.out.println("[#### Receiver ####] Fim do processo.");
           			
                
                } else {
                   
                	System.err.println("[#### Receiver ####] O ObjMessage não é do tipo Parameters");
               
                }
                
            } else {
                System.err.println("[#### Receiver ####] A mensagem não é do tipo Object");
            }

        } catch (Throwable t) {
            t.printStackTrace();
            context.setRollbackOnly();
        }
    }

}  
